#! /bin/sh
# This is a shell archive.  Remove anything before this line, then unpack
# it by saving it into a file and typing "sh file".  To overwrite existing
# files, type "sh file -c".  You can also feed this as standard input via
# unshar, or by typing "sh <file", e.g..  If this archive is complete, you
# will see the following message at the end:
#		"End of archive 1 (of 3)."
# Contents:  prolog1.2 prolog1.2/Interval prolog1.2/Interval/add.ss
#   prolog1.2/Interval/geq.ss prolog1.2/Interval/gt.ss
#   prolog1.2/Interval/int.ss prolog1.2/Interval/neq.ss
#   prolog1.2/Interval/precision.ss prolog1.2/Interval/split.ss
#   prolog1.2/README prolog1.2/Release prolog1.2/builtin.pro
#   prolog1.2/clauses.ss prolog1.2/compatibility.ss
#   prolog1.2/compile.ss prolog1.2/dlists.ss prolog1.2/ex.pro
#   prolog1.2/flounder.ss prolog1.2/goals.ss prolog1.2/interval.ss
#   prolog1.2/polytest.pro prolog1.2/predicates.ss
#   prolog1.2/programs.ss prolog1.2/prolog.ss prolog1.2/schedule.ss
#   prolog1.2/tables.ss
# Wrapped by oz@nexus.yorku.ca on Mon Jun 15 12:54:03 1992
PATH=/bin:/usr/bin:/usr/ucb ; export PATH
if test ! -d 'prolog1.2' ; then
    echo shar: Creating directory \"'prolog1.2'\"
    mkdir 'prolog1.2'
fi
if test ! -d 'prolog1.2/Interval' ; then
    echo shar: Creating directory \"'prolog1.2/Interval'\"
    mkdir 'prolog1.2/Interval'
fi
if test -f 'prolog1.2/Interval/add.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/add.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/add.ss'\" \(2360 characters\)
sed "s/^X//" >'prolog1.2/Interval/add.ss' <<'END_OF_FILE'
X
X;;; procedures
X(define (add i j k)
X					;;; i, j, k are intervals
X	(let*	((i+j (sum-int i j))
X		(knew (intersect k i+j))
X		(jnew (intersect j (minus k i)))
X		(inew (intersect i (minus k j))))
X		(list (add-examine inew jnew knew))))
X
X(define (sum-int i j)
X					;;; i, j are intervals
X	(append (addb (lb-type@ i) (lb@ i) (lb-type@ j) (lb@ j) '-)
X		(reverse (addb (ub-type@ i) (ub@ i) (ub-type@ j) (ub@ j) '+))))
X
X(define (addb bt-i b-i bt-j b-j round)
X					;;; bt-i, bt-j are the bound types
X					;;; and b-i, b-j are the bound values
X					;;; round is direction of rounding
X	(let ((bt (plust@ bt-i bt-j)))
X		(cond	((or (is-inf? b-i) (is-inf? b-j));;; neg infinity + any
X;;; (-w + any<0   =>  (-w
X;;; (-w + any>=0  =>  (-w
X;;; -w + w        =>  (round) +/-w
X;;; etc.
X				(list bt INF-))	;;; arguably wrong for -w + w
X			((or (isinf? b-i) (isinf? b-j))	;;; pos infinity + any
X				(list bt INF))
X			((=_ b-i ZERO)			;;; 0 + any
X				(list bt b-j))
X			((=_ b-j ZERO)			;;; any + 0
X				(list bt b-i))
X			(else				;;; finite + finite
X				(list	(open-bound bt)
X					(fuzz+_ b-i b-j round))))))
X
X(define (plust@ ti tj)
X	(lkup3@ ti tj PLUST))
X
X(define (fuzz+_ i j round)
X	(+_ (fuzzy i round) (fuzzy j round)))
X
X(define (fuzzy i round)
X	(*_ i (if (eq? round '+)
X		  (if (<_ i ZERO) FUZZ- FUZZ+)
X		  (if (<_ i ZERO) FUZZ+ FUZZ-))))
X
X(define (open-bound bt)
X	(lkup2@ bt OPEN-BRACKET))
X
X(define OPEN-BRACKET	'( (< <) ({ <) (} >) (> >) ))
X
X;;(define (sum-int i j)
X;;					;;; i, j are intervals
X;;	(append (addb (lb-type@ i) (lb@ i) (lb-type@ j) (lb@ j))
X;;		(reverse (addb (ub-type@ i) (ub@ i) (ub-type@ j) (ub@ j)))))
X;;
X;;(define (addb bt-i b-i bt-j b-j)
X;;					;;; bt-i, bt-j are the bound types
X;;					;;; and b-i, b-j are the bound values
X;;	(list (plust@ bt-i bt-j) (plus@ b-i b-j)))
X;;
X;;(define (plust@ ti tj)
X;;	(lkup3@ ti tj PLUST))
X;;
X;;(define (plus@ i j)
X;;	(cond	((or (is-inf? i) (is-inf? j))
X;;			INF-)
X;;		((or (isinf? i) (isinf? j))
X;;			INF)
X;;		(else	(+_ i j))))
X
X(define (minus i j)
X					;;; i, j are intervals
X	(sum-int i (uminus j)))
X
X(define (add-examine i j k)
X					;;; i, j, k are intervals
X	(list	(cond	((or (empty? i) (empty? j) (empty? k))
X				FAIL)
X			((and (point? i) (point? j) (point? k))
X				COMPLETE-SUCCESS)
X			(else	RETAIN))
X		i j k))
X
X;;; constants
X(define PLUST '((> > >)	(> } >)
X		({ { {) ({ < <)
X		(} > >) (} } })
X		(< { <) (< < <)))
X
END_OF_FILE
if test 2360 -ne `wc -c <'prolog1.2/Interval/add.ss'`; then
    echo shar: \"'prolog1.2/Interval/add.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/add.ss'
fi
if test -f 'prolog1.2/Interval/geq.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/geq.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/geq.ss'\" \(706 characters\)
sed "s/^X//" >'prolog1.2/Interval/geq.ss' <<'END_OF_FILE'
X
X(define (geq i j)
X					;;; i, j are intervals
X	(let*	((i-lbt (lb-type@ i))
X		(i-lb (lb@ i))
X		(i-ub (ub@ i))
X		(i-ubt (ub-type@ i))
X		(j-lbt (lb-type@ j))
X		(j-lb (lb@ j))
X		(j-ub (ub@ j))
X		(j-ubt (ub-type@ j))
X		(i~ (intersect i (append (imax i-lbt i-lb j-lbt j-lb)
X					(list i-ub i-ubt))))
X					;;; bad access mechanism
X					;;; use define-structure??
X		(j~ (intersect j
X			(append (list j-lbt j-lb)
X				(reverse (imin j-ubt j-ub i-ubt i-ub))))))
X		(list (geq-examine i~ j~))))
X
X(define (geq-examine i j)
X					;;; i, j are intervals
X	(list	(cond	((or (empty? i) (empty? j))
X				FAIL)
X					;;; note departure from the paper!!##
X			((>= (lb@ i) (ub@ j))
X				COMPLETE-SUCCESS)
X			(else	RETAIN))
X		i j))
X
END_OF_FILE
if test 706 -ne `wc -c <'prolog1.2/Interval/geq.ss'`; then
    echo shar: \"'prolog1.2/Interval/geq.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/geq.ss'
fi
if test -f 'prolog1.2/Interval/gt.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/gt.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/gt.ss'\" \(1293 characters\)
sed "s/^X//" >'prolog1.2/Interval/gt.ss' <<'END_OF_FILE'
X
X;;; i, j are arithmetic intervals
X(define (gt i j)
X	(let*	((i-lbt (lb-type@ i))
X		(i-lb (lb@ i))
X		(i-ub (ub@ i))
X		(i-ubt (ub-type@ i))
X		(j-lbt (lb-type@ j))
X		(j-lb (lb@ j))
X		(j-ub (ub@ j))
X		(j-ubt (ub-type@ j))
X		(i~ (append (shift-max i-lbt i-lb j-lbt j-lb)
X				(list i-ub i-ubt)))
X					;;; bad access mechanism
X					;;; use define-structure??
X		(j~ (append (list j-lbt j-lb)
X			(reverse (shift-min i-ubt i-ub j-ubt j-ub)))))
X		(list (geq-examine i~ j~))))
X
X(define (gt-examine i j)
X					;;; i, j are intervals
X	(list	(cond	((or (empty? i) (empty? j))
X				FAIL)
X					;;; note departure from the paper!!##
X			((> (lb@ i) (ub@ j))
X				COMPLETE-SUCCESS)
X			((and	(= (lb@ i) (ub@ j))
X				(or (lb-open? (lb@ i)) (ub-open? (ub@ j))))
X				COMPLETE-SUCCESS)
X			(else	RETAIN))
X		i j))
X
X(define (shift-max i-lbt i-lb j-lbt j-lb)
X	(let*	((m (imax i-lbt i-lb j-lbt j-lb))
X		(mbt (car m))
X		(mb (cadr m))
X		(match? (and (equal? mbt j-lbt) (=_ mb j-lb))))
X		(if	match?
X			(list	(if	(lb-closed? j-lbt)
X					LB-OPEN
X					j-lbt)
X				j-lb)
X			m)))
X
X(define (shift-min i-ubt i-ub j-ubt j-ub)
X	(let*	((m (imin i-ubt i-ub j-ubt j-ub))
X		(mbt (car m))
X		(mb (cadr m))
X		(match? (and (equal? mbt i-ubt) (=_ mb i-ub))))
X		(if	match?
X			(list	(if	(ub-closed? i-ubt)
X					UB-OPEN
X					i-ubt)
X				i-ub)
X			m)))
X
END_OF_FILE
if test 1293 -ne `wc -c <'prolog1.2/Interval/gt.ss'`; then
    echo shar: \"'prolog1.2/Interval/gt.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/gt.ss'
fi
if test -f 'prolog1.2/Interval/int.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/int.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/int.ss'\" \(1229 characters\)
sed "s/^X//" >'prolog1.2/Interval/int.ss' <<'END_OF_FILE'
X
X(define (int i)
X				;;; i is an interval
X	(let*	((i-lbt (lb-type@ i))
X		(i-lb (lb@ i))
X		(i-ub (ub@ i))
X		(i-ubt (ub-type@ i))
X		(result	(append (int-ceiling i-lbt i-lb)
X				(int-floor i-ubt i-ub))))
X		(list (int-examine result))))
X
X(define (int-examine i)
X				;;; i is an interval
X	(list	(let	((i-lb (lb@ i)))
X			(cond	((empty? i)
X					FAIL)
X				((and (point? i) (is-integer? i-lb))
X					COMPLETE-SUCCESS)
X				(else	RETAIN)))
X		i))
X				;;; can make this stricter by checking whether
X				;;; an integer can occur in the interval!?
X
X(define (is-integer? x)
X				;;; x is an internal real
X	(or	(isinf? x)
X		(is-inf? x)
X		(= x (real (ceiling x)))))
X
X(define (int-ceiling bt b)
X	(cond	((or (isinf? b) (is-inf? b))
X			(list LB-CLOSED b))
X		(else	(let	((result (real (ceiling b))))
X				(list	LB-CLOSED
X					(cond	((and	(= result b)
X							(<t? LB-CLOSED bt))
X							(+_ result ONE))
X						(else	result)))))))
X
X(define (int-floor bt b)
X					;;; 2.3 > -> 2.0 }
X					;;; 2.0 > -> 1.0 }
X					;;; 2.0 } -> 2.0 }
X	(cond	((or (isinf? b) (is-inf? b))
X			(list b UB-CLOSED))
X		(else	(let	((result (real (floor b))))
X				(list	(cond	((and	(= result b)
X							(<t? bt UB-CLOSED))
X							(-_ result ONE))
X						(else	result))
X					UB-CLOSED)))))
X
END_OF_FILE
if test 1229 -ne `wc -c <'prolog1.2/Interval/int.ss'`; then
    echo shar: \"'prolog1.2/Interval/int.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/int.ss'
fi
if test -f 'prolog1.2/Interval/neq.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/neq.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/neq.ss'\" \(1129 characters\)
sed "s/^X//" >'prolog1.2/Interval/neq.ss' <<'END_OF_FILE'
X
X(define (neq i j)
X					;;; i, j are intervals
X	(cond	((and (point? i) (not (point? j)))
X			(let*	((i-lb (lb@ i))
X				(j-split (neq-split j i-lb))
X				(j-left (car j-split))
X				(j-right (cadr j-split)))
X				(list	(neq-examine i j-left)
X					(neq-examine i j-right))))
X		((and (point? j) (not (point? i)))
X			(let*	((j-lb (lb@ j))
X				(i-split (neq-split i j-lb))
X				(i-left (car i-split))
X				(i-right (cadr i-split)))
X				(list	(neq-examine i-left j)
X					(neq-examine i-right j))))
X		(else	(list (neq-examine i j)))))
X					;;; neither is a point interval?
X
X(define (neq-examine i j)
X					;;; i, j are intervals
X					;;; (probably squeezed)
X	(list	(cond	((or (empty? i) (empty? j))
X				FAIL)
X			((not (or (point? i) (point? j)))
X					;;; neither is a point?
X				RETAIN)
X			(else	(cond	((eq-int? i j)	FAIL)
X					(else		COMPLETE-SUCCESS))))
X		i j))
X
X(define (neq-split i wrt)
X					;;; i is an interval
X					;;; wrt is an internal real
X	(let	((i-lbt (lb-type@ i))
X		(i-lb (lb@ i))
X		(i-ub (ub@ i))
X		(i-ubt (ub-type@ i)))
X		(list	(list i-lbt i-lb wrt UB-OPEN)
X			(list LB-OPEN wrt i-ub i-ubt))))
X					;;; bad access mechanism??
X
END_OF_FILE
if test 1129 -ne `wc -c <'prolog1.2/Interval/neq.ss'`; then
    echo shar: \"'prolog1.2/Interval/neq.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/neq.ss'
fi
if test -f 'prolog1.2/Interval/precision.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/precision.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/precision.ss'\" \(2004 characters\)
sed "s/^X//" >'prolog1.2/Interval/precision.ss' <<'END_OF_FILE'
X
X;;; functions
X(define (real x) x)
X					;;; (exact->inexact ...) required?
X
X(define (approx const)			;;; const is an integer/real constant
X					;;; of "infinite" precision
X	(mk-interval LB-CLOSED (real const) (real const) UB-CLOSED))
X					;;; bring down the precision??##
X
X(define (hack x)
X					;;; x is an internal real
X	(cond	((isinf? x)	INFMAX)
X		((is-inf? x)	-INFMAX)
X		(else		x)))
X
X(define (avg x y)
X					;;; x, y are internal reals
X	(let	((x~ (hack x))
X    		(y~ (hack y)))
X		(/_ (+_ x~ y~) TWO)))
X
X;;; low-level primitives
X(define (<_ x y)
X					;;; EXACT <
X					;;; x, y are internal reals
X	(cond	((equal? x y)			#f)
X		((or (is-inf? x) (isinf? y))	#t)
X		((or (isinf? x) (is-inf? y))	#f)
X		(else				(< x y))))
X
X(define (=_ x y)
X					;;; EXACT =
X					;;; x, y are internal reals
X	(cond	((equal? x y)	#t)
X		((or (isinf? x) (isinf? y) (is-inf? x) (is-inf? y))
X			#f)
X		(else	(= x y))))
X
X(define (~<_ x y) (<_ x y))
X					;;; INEXACT <
X					;;; x, y are non-infinite reals
X
X(define (~_a x y prec)
X					;;; INEXACT = (absolute)
X					;;; x, y are non-infinite reals
X					;;; prec is a real >= 0
X	(and	(<= (-_ x y) prec)
X		(<= (-_ y x) prec)))
X
X(define (~_r x y prec)
X					;;; INEXACT = (relative)
X					;;; x, y are non-infinite reals
X	(let	((prec+ (+ 1 prec)) (prec- (- 1 prec)))
X		(and	(<= x (*_ y (if (<_ y ZERO) prec- prec+)))
X			(<= y (*_ x (if (<_ x ZERO) prec- prec+))))))
X
X(define (~_m x y)
X					;;; INEXACT = (machine relative)
X					;;; x, y are non-infinite reals
X	(and	(<= x (*_ y (if (<_ y ZERO) FUZZ- FUZZ+)))
X		(<= y (*_ x (if (<_ x ZERO) FUZZ- FUZZ+)))))
X
X;;; constants
X(define INFMAX		(real 999999999999.999))
X(define -INFMAX		(real (- 0.0 999999999999.999)))
X
X(define (find-fuzz e)
X	(let* ((x 1.0) (epsilon (/ e 2.0)) (y (* x (+ 1.0 epsilon))))
X	      (if (equal? x y) e (find-fuzz epsilon))))
X(define FUZZ	(find-fuzz 1.0))	;;; addend for fuzzing intervals
X(define FUZZ+	(+ 1.0 FUZZ))		;;; multiplier for fuzzing intervals
X(define FUZZ-	(- 1.0 FUZZ))		;;; multiplier for fuzzing intervals
END_OF_FILE
if test 2004 -ne `wc -c <'prolog1.2/Interval/precision.ss'`; then
    echo shar: \"'prolog1.2/Interval/precision.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/precision.ss'
fi
if test -f 'prolog1.2/Interval/split.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Interval/split.ss'\"
else
echo shar: Extracting \"'prolog1.2/Interval/split.ss'\" \(2954 characters\)
sed "s/^X//" >'prolog1.2/Interval/split.ss' <<'END_OF_FILE'
X
X;;; functions
X(define (split-abs prec i)
X					;;; i is an interval
X					;;; prec is a real number
X	(do-split (cons 'abs prec) i))
X
X(define (split-rel prec i)
X					;;; i is an interval
X					;;; prec is a real number
X	(do-split (cons 'rel prec) i))
X
X(define (split-machine i)
X					;;; i is an interval
X	(do-split (cons 'machine '()) i))
X
X(define split split-machine)
X
X(define (splitting-precision how)
X	(let*	((int (cdr how))
X		 (prec (ub@ int)))
X		(cond	((empty? int)
X				(error 'split "empty precision interval"))
X			((not (number? prec))
X				(error 'split "bad precision ~s" prec))
X			((< prec FUZZ)
X				(error 'split "bad precision ~s" prec))
X			(else prec))))
X
X(define (do-split how i)
X					;;; i is an interval
X    	(let*	((i-lbt (lb-type@ i))
X		 (i-lb (lb@ i))
X		 (i-ub (ub@ i))
X		 (i-ubt (ub-type@ i))
X		 (compare
X			(case (car how)
X				((abs) (lambda (x y)
X					  (~_a x y (splitting-precision how))))
X				((rel) (lambda (x y)
X					  (~_r x y (splitting-precision how))))
X				((machine) (lambda (x y) (~_m x y)))))
X		 (examine (lambda (int) (split-examine int compare))))
X(arith-debug "do-split interval:")
X(arith-debug i)
X		(cond	((empty? i)
X				(list (examine EMPTY)))
X			((point? i)
X				(list (examine i)))
X			((adj? i-lb i-ub compare)
X					;;; note (not (empty? i))
X				(cond	((and	(lb-open? i-lbt)
X						(ub-open? i-ubt))
X						(list (examine i)))
X					((and	(lb-open? i-lbt)
X						(ub-closed? i-ubt))
X						(let	((i1 (list LB-OPEN i-lb
X								i-ub UB-OPEN))
X							(i2 (list LB-CLOSED i-ub
X								i-ub UB-CLOSED)))
X							(list	(examine i1)
X								(examine i2))))
X					;;; i-lbt == LB-CLOSED for sure
X					((ub-open? i-ubt)
X						(let	((i1 (list LB-CLOSED i-lb
X								i-lb UB-CLOSED))
X							(i2 (list LB-OPEN i-lb
X								i-ub UB-OPEN)))
X							(list	(examine i1)
X								(examine i2))))
X					;;; i-ubt == UB-CLOSED for sure too
X					(else	(let	((i1 (list LB-CLOSED i-lb
X								i-lb UB-CLOSED))
X							(i2 (list LB-OPEN i-lb
X								i-ub UB-OPEN))
X							(i3 (list LB-CLOSED i-ub
X								i-ub UB-CLOSED)))
X							(list	(examine i1)
X								(examine i2)
X								(examine i3))))))
X    			(else	(let*	((mid (avg i-lb i-ub))
X    					(i1 (list i-lbt i-lb mid
X    							UB-OPEN))
X    					(i2 (list LB-CLOSED mid i-ub
X    							i-ubt)))
X(arith-debug "split thus:")
X(arith-debug i1)
X(arith-debug i2)
X    					(list	(examine i1)
X    						(examine i2)))))))
X
X(define (split-examine i compare)
X					;;; i is an interval
X	(list	(cond	((point? i)
X				COMPLETE-SUCCESS)
X    			((empty? i)
X				FAIL)
X			(else	(let	((i-lbt (lb-type@ i))
X					(i-lb (lb@ i))
X					(i-ub (ub@ i))
X					(i-ubt (ub-type@ i)))
X					(cond	((and	(lb-open? i-lbt)
X							(ub-open? i-ubt)
X							(adj? i-lb i-ub compare))
X							COMPLETE-SUCCESS)
X						(else	RETAIN)))))
X		i))
X
X(define (adj? x y compare)		;;; INEXACT
X					;;; x, y are internal reals
X					;;; assumes that x <= y
X    	(if	(or (isinf? x) (isinf? y) (is-inf? x) (is-inf? y))
X    		#f
X    		(compare x y)))
X
END_OF_FILE
if test 2954 -ne `wc -c <'prolog1.2/Interval/split.ss'`; then
    echo shar: \"'prolog1.2/Interval/split.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Interval/split.ss'
fi
if test -f 'prolog1.2/README' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/README'\"
else
echo shar: Extracting \"'prolog1.2/README'\" \(1311 characters\)
sed "s/^X//" >'prolog1.2/README' <<'END_OF_FILE'
X				Scheme Prolog 1.2
X				-----------------
X
X	written by John Cleary, Alan Dewar, Vinit Kaushik and Sue Rempel
X	at the University of Calgary (cleary@cpsc.ucalgary.ca).
X
XThis package provides a fairly simple interpreter for pure Prolog, implemented
Xin Scheme.  It is primarily intended for use in students' projects involving
Ximplementations of Prolog.  Scheme Prolog version 1.2 is mostly a pure Prolog
Xinterpreter, though a few built-in primitives are also included.  Delayed goals
Xare also supported, and an interval-arithmetic package is included.
X
XThe interval arithmetic is a form of constraint solving on real variables.
XIt is logically correct in the sense that no solutions to constraints are ever
Xrejected.  It deals correctly with rounding and truncation and can solve
Xnon-linear constraints.
X
XThis implementation runs on Chez Scheme and on Elk, and is intended to be
Xportable to other Scheme implementations.
X
XInstallation instructions and release notes may be found in the file "Release".
XFor details on invoking Scheme Prolog and on the built-in routines supported,
Xrefer to "Manual".  For implementation details, refer to "Impl".  For details
Xon the interval-arithmetic package, refer to the following paper:
X
X	Cleary, John G. (1987)  "Logical Arithmetic," Future Computing
X	Systems 2(2) 125-149.
END_OF_FILE
if test 1311 -ne `wc -c <'prolog1.2/README'`; then
    echo shar: \"'prolog1.2/README'\" unpacked with wrong size!
fi
# end of 'prolog1.2/README'
fi
if test -f 'prolog1.2/Release' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/Release'\"
else
echo shar: Extracting \"'prolog1.2/Release'\" \(4204 characters\)
sed "s/^X//" >'prolog1.2/Release' <<'END_OF_FILE'
X		Release Notes for Scheme Prolog 1.2
X		-----------------------------------
X
XThis release fixes a number of bugs which were present in the original
X(version 1.1) release.  Some minor enhancements are also present.
X
X
XBUGS FIXED
X----------
X
X() vs. #f
X
X    This release recognizes the difference between the empty list and
X    the false constant.  Older implementations of Scheme treated these
X    as identical, and the 1.1 release assumed this behaviour.  This
X    assumption is no longer made.
X
Xrepeated variables in arithmetic expressions
X
X    Two or more occurrences of the same variable in an arithmetic
X    expression (e.g., (add ?x ?x ?y)) were not handled correctly.
X    The interpreter now transforms such goals to remove multiple
X    occurrences (e.g., (add ?x ?x ?y) becomes (mult 2 ?x ?y)).
X
Xretained-goal "leaks"
X
X    Retained arithmetic goals (i.e., those which are kept for later
X    re-execution upon further squeezing of their argument intervals)
X    were sometimes allowed to persist beyond backtracking out of the
X    invoking goal.  This no longer occurs.
X
Xrepetition of retained goals
X
X    A goal to be delayed on a variable used to show up more than once
X    in the variable's delay list, in certain situations, leading to
X    needless re-executions.  The interpreter now avoids this by not
X    delaying a goal on a variable if it is already so delayed.
X
Xgeq
X
X    geq goals were sometimes incorrectly retained.
X
X
XENHANCEMENTS
X------------
X
Xdebugging
X
X    The user-level debugging (invoked via the `debug' builtin) now
X    produces more output.  This includes the display of goal numbers,
X    for easier cross reference by users; better tracking of the waking
X    of delayed goals upon variable instantiation; and tracking of the
X    lists of delayed goals on variables.
X
Xsolution output
X
X    The lists of floundered and splitting goals are now displayed with
X    only one goal per line, instead of all on a single line.
X
Xretained-goal scheduling
X
X    Instead of executing retained goals immediately upon instantiation
X    of any variable upon which they are delayed, the interpreter now
X    queues these goals for later execution, following the completion of
X    the goal which is currently executing.  This avoids execution of
X    the same goal twice (or more) when two (or more) of its variables
X    become instantiated during execution of some other goal.
X
Xlocation of files
X
X    It is no longer necessary to keep all system files and user files
X    together in the same directory.
X
Xbuiltins
X
X    New built-in predicates include true, fail, and square, as well
X    as a number of arithmetic primitives used for internal purposes.
X
Xexamples
X
X    More examples of interval arithmetic are included.
X
X
XINSTALLATION
X------------
X
XThe files comprising this release may be installed in any directory.
XThe suggested approach is to install the Scheme sources for the pure
XProlog interpreter in one directory, with the interval-arithmetic
XScheme sources in a sub-directory named "Interval".  The system
XProlog files ("builtin.pro" and "interval.pro") may reside in the
Xsame directory as the pure-Prolog Scheme sources.
X
XThe file "prolog.ss" should be modified appropriately to reflect the
Xinstallation location(s).  If the above approach is followed, only
Xone definition need be changed:  prolog-source-prefix must be set to
Xa string naming the installation directory.  A trailing slash (or
Xother appropriate delimiter, for non-Unix systems) MUST BE INCLUDED,
Xas the string is directly prepended to the names of the system Prolog
Xfiles.
X
XIf the interval-arithmetic Scheme sources or the system Prolog files
Xare to reside in locations other than as described above, it is
Xnecessary to change the definitions of interval-source-prefix and
Xprolog-source-prefix in "prolog.ss" appropriately.
X
XSince not all implementations of Scheme are identical, it may be
Xnecessary to provide certain definitions which are used by Scheme
XProlog, but which your Scheme does not provide.  Such definitions
Xshould be added to "compatibility.ss".
X
X
XBUG REPORTING
X-------------
X
XPlease report any bugs via email to dewar@cpsc.ucalgary.ca and/or to
Xcleary@cpsc.ucalgary.ca.  Questions and comments are also welcome.
END_OF_FILE
if test 4204 -ne `wc -c <'prolog1.2/Release'`; then
    echo shar: \"'prolog1.2/Release'\" unpacked with wrong size!
fi
# end of 'prolog1.2/Release'
fi
if test -f 'prolog1.2/builtin.pro' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/builtin.pro'\"
else
echo shar: Extracting \"'prolog1.2/builtin.pro'\" \(754 characters\)
sed "s/^X//" >'prolog1.2/builtin.pro' <<'END_OF_FILE'
X(when (true))
X(how (true)
X	(lambda (goal program s f)
X		(s f)))
X
X(when (fail))
X(how (fail)
X	(lambda (goal program s f)
X		(f)))
X
X(when (findall ?vars ?goal ?bag))
X(how (findall ?vars ?goal ?bag)
X	(lambda (goal program s f)
X		(let*	((g-term (goal-term goal))
X			(g (term-deref (comp-caddr g-term))))
X			(arith-debug "in findall() with goal:")
X			(arith-debug (term-instantiate g-term))
X			(unify	(all-solutions
X					(term-deref (comp-cadr g-term))
X					(if	(and (term-var? g) (var-inst? g))
X						(var-val g)
X						g)
X					program)
X				(term-deref (comp-cadddr g-term)) program s f))))
X
X(when (not ?goal))
X(what (not ?goal)
X	(findall ?any ?goal ()))
X
X(when (debug))
X(how (debug)
X	(lambda (goal program s f)
X		(set! user-debug? (not user-debug?))
X		(s f)))
END_OF_FILE
if test 754 -ne `wc -c <'prolog1.2/builtin.pro'`; then
    echo shar: \"'prolog1.2/builtin.pro'\" unpacked with wrong size!
fi
# end of 'prolog1.2/builtin.pro'
fi
if test -f 'prolog1.2/clauses.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/clauses.ss'\"
else
echo shar: Extracting \"'prolog1.2/clauses.ss'\" \(375 characters\)
sed "s/^X//" >'prolog1.2/clauses.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Clauses:  implemented as lists of the form (head . body)
X;;;           where body is a list of terms.
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define clause-head car)
X(define clause-body cdr)
X(define (clause-fact? clause) (null? (clause-body clause)))
END_OF_FILE
if test 375 -ne `wc -c <'prolog1.2/clauses.ss'`; then
    echo shar: \"'prolog1.2/clauses.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/clauses.ss'
fi
if test -f 'prolog1.2/compatibility.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/compatibility.ss'\"
else
echo shar: Extracting \"'prolog1.2/compatibility.ss'\" \(654 characters\)
sed "s/^X//" >'prolog1.2/compatibility.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Compatibility:  definitions which are not built in to your Scheme
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define elk-compatibility #f)
X; (define foo-compatibility #f)
X; etc.; add your own compatibility definitions below, and enable any
X;       appropriate ones above.
X
X;;;; Definitions for Elk (Extension Language Kit, from Oliver Laumann)
X(if elk-compatibility
X	(define (cpu-time) 0))		; not essential, so fake it
X(if elk-compatibility
X	(define (list-copy x)
X		(if (null? x)
X		    '()
X		    (cons (car x) (list-copy (cdr x))))))
END_OF_FILE
if test 654 -ne `wc -c <'prolog1.2/compatibility.ss'`; then
    echo shar: \"'prolog1.2/compatibility.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/compatibility.ss'
fi
if test -f 'prolog1.2/compile.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/compile.ss'\"
else
echo shar: Extracting \"'prolog1.2/compile.ss'\" \(3939 characters\)
sed "s/^X//" >'prolog1.2/compile.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Compile
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define (program-var? term) ;was syntactic-var
X  (if (symbol? term)
X      (eq? #\? (string-ref (symbol->string term) 0))
X      #f))
X
X;;; assumes term-find-path never returns #f (ie variables in the body of the
X;;;    clause always appear in the head)                               
X(define (compile-when-clause clause)
X  (cons
X   'and 
X   (map
X    (lambda (body-term)
X      (let ((function
X             (case
X                (car body-term)
X                 ((nonvar) 'term-not-var?)
X                 ((ground) 'term-ground?)
X                (else 
X                 (error 'when-clause "invalid constraint ~s" clause))))
X	    (path (term-find-path (cadr body-term) (clause-head clause))))
X        `(let ((rest-length/end
X               (term-follow-path 
X                goal-term
X                ,path)))
X          (if (zero? (car rest-length/end))
X              (,function (cdr rest-length/end))
X              #f))))
X    (clause-body clause))))
X
X;;; returns a procedure which takes a goal as an argument. The returned
X;;; procedure returns true iff the goal is ready to run
X
X(define (compile-when when-clause-list)
X  (eval
X   `(lambda (goal)
X            (let ((goal-term (goal-term goal)))
X            ,(cons 'or
X                   (map compile-when-clause
X                        when-clause-list))))))
X
X(define (compile-what-clause clause)
X  
X  (define (make-vars/body-program term)
X    ;;; sample call:
X    ;;;   (make-vars/body-program 
X    ;;;       '((append (?H . ?T) ?L (?H . ?NT)) (append ?T ?L ?NT)))
X    ;;; =>
X    ;;;   ((?H ?T ?L ?NT) .
X    ;;;    (comp-cons
X    ;;;     (comp-cons 'append
X    ;;;        (comp-cons
X    ;;;           (comp-cons ?H ?T)
X    ;;;           (comp-cons ?L (comp-cons (comp-cons ?H ?NT) '()))))
X    ;;;     (comp-cons
X    ;;;        (comp-cons 'append
X    ;;;           (comp-cons ?T (comp-cons ?L (comp-cons ?NT '()))))
X    ;;;        '())))
X    
X    (define (vars-union vars1 vars2)   ; similar to no-dups
X      (cond ((null? vars1) vars2)
X            ((member (car vars1) vars2)
X             (vars-union (cdr vars1) vars2))
X            (else
X             (cons (car vars1) (vars-union (cdr vars1) vars2)))))
X    (cond ((program-var? term) (cons (list term) term))
X          ((term-const? term) (cons '() `',term))
X          ((term-comp? term)
X           (let ((vars/body-program1
X                  (make-vars/body-program (comp-car term)))
X                 (vars/body-program2
X                  (make-vars/body-program (comp-cdr term))))
X             (cons
X              (vars-union (car vars/body-program1)
X                          (car vars/body-program2))
X              `(comp-cons ,(cdr vars/body-program1)
X                          ,(cdr vars/body-program2)))))))
X  (define (make-bindings-program vars)
X    (map (lambda (var) `(,var (make-var ',var))) vars))
X  (let ((vars/body-program (make-vars/body-program clause)))
X    (eval
X     `(lambda ()
X              (let ,(make-bindings-program (car vars/body-program))
X                ,(cdr vars/body-program))))))
X
X;;; 
X(define (compile-what what-clause-list)
X  (map compile-what-clause
X       what-clause-list))
X
X;;; assume a how clause list has only one element, which is a "clause" whose
X;;; only "goal" in the body is a program which defines a procedure capable of
X;;; solving an and-branch
X(define (compile-how how-clause-list)
X	(if	(null? how-clause-list)
X		'()
X		(eval (comp-car (clause-body (car how-clause-list))))))
X
X(define (compile-program! program)
X	(map	(lambda (assoc)
X			(let	((pred (assoc-value assoc)))
X				(pred-when! pred
X					(compile-when
X						(dlist->list (pred-when pred))))
X				(pred-what! pred
X					(compile-what
X						(dlist->list (pred-what pred))))
X				(pred-how! pred
X					(compile-how
X						(dlist->list (pred-how pred))))))
X		program))
X
END_OF_FILE
if test 3939 -ne `wc -c <'prolog1.2/compile.ss'`; then
    echo shar: \"'prolog1.2/compile.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/compile.ss'
fi
if test -f 'prolog1.2/dlists.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/dlists.ss'\"
else
echo shar: Extracting \"'prolog1.2/dlists.ss'\" \(3372 characters\)
sed "s/^X//" >'prolog1.2/dlists.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; dlists:  difference lists implemented with pairs.
X;;;          A pair is used as a header to point to the first and last
X;;;          pair of the dlist.
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X;;; test
X(define (dlist? x)
X  (if (pair? x)
X      (if (proper-list? (car x))
X          (if (null? (car x))
X              (null? (cdr x))
X              (eq? (last-pair (car x)) (cdr x)))
X          #f)
X      #f))
X
X;;; constructors
X(define (make-dlist) (cons '() '()))
X(define (dlist . l)
X  (if (null? l)
X      (cons '() '())
X      (cons l (last-pair l))))
X
X;;; conversion
X(define (list->dlist list)
X  (if (null? list)
X      (cons '() '())
X      (cons list (last-pair list))))
X(define dlist->list car)
X
X;;; empty dlist
X(define (dlist-empty? dlist) (null? (car dlist)))
X
X;;; add to front
X(define (dlist-insert-front! x dlist)
X  (if (null? (car dlist))
X      (begin
X       (set-car! dlist (cons x '()))
X       (set-cdr! dlist (car dlist)))
X      (set-car! dlist (cons x (car dlist)))))
X
X;;; add to back
X(define (dlist-insert-back! x dlist)
X  (if (null? (car dlist))
X      (begin
X       (set-car! dlist (cons x '()))
X       (set-cdr! dlist (car dlist)))
X      (begin
X       (set-cdr! (cdr dlist) (cons x '()))
X       (set-cdr! dlist (cddr dlist)))))
X
X;;; add anywhere
X(define (dlist-insert-anywhere! x dlist)
X	(dlist-insert-front! x dlist))
X
X;;; assumes l is a proper list with at least 2 items in l
X(define (list-2nd-last-pair l)
X  (if (null? (cddr l)) 
X             l
X             (list-2nd-last-pair (cdr l))))
X
X;;; delete from front
X(define (dlist-delete-front! dlist)
X	(cond	((dlist-empty? dlist)
X			(error 'dlist-delete-front!
X				"attempt to delete from empty list"))
X		((null? (cdar dlist))		;;; lone pair in dlist?
X			(let	((ret (caar dlist)))
X				(set-car! dlist '())
X				(set-cdr! dlist '())
X				ret))
X		(else	(let	((ret (caar dlist)))
X				(set-car! dlist (cdar dlist))
X				ret))))
X
X;;; delete from back
X(define (dlist-delete-back! dlist)
X	(cond	((dlist-empty? dlist)
X			(error 'dlist-delete-back!
X				"attempt to delete from empty dlist"))
X		((null? (cdar dlist))
X					;;; 1 pair in dlist? return loner!
X			(let	((ret (caar dlist)))
X				(set-car! dlist '())
X				(set-cdr! dlist '())
X				ret))
X		(else	(let	((ret (cadr dlist)))
X				(set-cdr! dlist
X					(list-2nd-last-pair (car dlist)))
X				(set-cdr! (cdr dlist) '())
X				ret))))
X
X;;; deletes x from dlist
X(define (dlist-delete! x dlist)
X						;;; does not complain if x does
X						;;; not exist in dlist
X	(define (delete! p1 p2)
X		(cond	((null? p2))
X			((eq? x (car p2))
X				(set-cdr! p1 (cdr p2))
X				(if	(null? (cdr p1))
X					(set-cdr! dlist p1)))
X						;;; p2 pointed to last pair
X			(else (delete! p2 (cdr p2)))))
X
X	(cond	((dlist-empty? dlist))
X		((null? (cdar dlist))
X			(if	(eq? x (caar dlist))
X				(begin		;;; delete only element
X						;;; same as dlist-delete-front!
X					(set-car! dlist '())
X					(set-cdr! dlist '()))))
X		(else	(if	(eq? x (caar dlist))
X						;;; at this stage x cannot be
X						;;; the last element in dlist
X				(set-car! dlist (cdar dlist))
X						;;; delete first element
X				(delete! (car dlist) (cdar dlist))))))
X						;;; search for x
X
X;;; append two dlists
X(define (dlist-append! dlist1 dlist2)
X  (set-cdr! (cdr dlist1) (car dlist2))
X  (set-cdr! dlist1 (cdr dlist2)))
END_OF_FILE
if test 3372 -ne `wc -c <'prolog1.2/dlists.ss'`; then
    echo shar: \"'prolog1.2/dlists.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/dlists.ss'
fi
if test -f 'prolog1.2/ex.pro' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/ex.pro'\"
else
echo shar: Extracting \"'prolog1.2/ex.pro'\" \(1617 characters\)
sed "s/^X//" >'prolog1.2/ex.pro' <<'END_OF_FILE'
X
X(when (app ?L1 ?L2 ?L3) (nonvar ?L1) (nonvar ?L2))
X(when (app ?L1 ?L2 ?L3) (nonvar ?L3))
X(what (app () ?L ?L) )
X(what (app (?H . ?T) ?L (?H . ?NT)) (app ?T ?L ?NT))
X
X(when (unified ?X ?X))
X(what (unified ?X ?X))
X
X(when (nrev ?L1 ?L2) (nonvar ?L1))
X(what (nrev () ()))
X(what (nrev (?H . ?T) ?L) (nrev ?T ?S) (app ?S (?H) ?L))
X
X(when (rev ?L1 ?L2) (nonvar ?L1))
X(what (rev ?L1 ?L2) (rev3 ?L1 () ?L2))
X
X(when (rev3 ?L1 ?L2 ?L3) (nonvar ?L1) (nonvar ?L2))
X(what (rev3 (?X . ?L) ?L2 ?L3) (rev3 ?L (?X . ?L2) ?L3))
X(what (rev3 () ?L ?L))
X
X(when (half ?S ?X))
X(what (half ?S ?X)
X	(add ?X ?X ?S) (split ?X))
X
X(when (root ?S ?R))
X(what (root ?S ?R)
X	(mult ?R ?R ?S) (split ?R))
X
X;; poly:  Find solution to the equation X^3-6X^2-7X-6 = 0
X(when (poly ?X))
X(what (poly ?X)
X	(add 6 ?A ?X) (mult ?X ?A ?B) (add 7 ?C ?B) (mult ?X ?C 6))
X
X;; simult:  Solve simultaneous equations X+Y=1, X-Y=2.
X(when (simult ?X ?Y))
X(what (simult ?X ?Y)
X	(add ?X ?Y 1) (add ?Y 2 ?X) (split ?X) (split ?Y))
X
X(when (divisors ?X ?Y ?Z))
X(what (divisors ?X ?Y ?Z)
X	(mult ?X ?Y ?Z) (geq ?X 1) (neq ?X 1) (geq ?Y ?X)
X	(int ?X) (int ?Y) (int ?Z)) 
X
X(when (mod ?X ?Y ?Z))
X(what (mod ?X ?Y ?Z)
X	(int ?X) (int ?Y) (int ?Z)
X	(geq ?Y 1) (add ?M ?Z ?X) (mult ?Y ?N ?M)
X	(int ?N) (geq ?Z 0) (geq ?Y ?Z) (neq ?Y ?Z))
X(what (mod ?X ?Y ?Z)
X	(int ?X) (int ?Y) (int ?Z)
X	(geq -1 ?Y) (add ?M ?Z ?X) (mult ?Y ?N ?M)
X	(int ?N) (geq 0 ?Z) (geq ?Z ?Y) (neq ?Y ?Z))
X
X(when (fact ?N ?R))
X(what (fact 0 1))
X(what (fact 1 1))
X(what (fact ?N ?R)
X	(int ?N) (geq ?N 2) (add ?M 1 ?N) (geq ?R ?N) (mult ?Z ?N ?R)
X	(fact ?M ?Z))
X
X(when (floun ?X))
X(what (floun ?X)
X	(app ?A ?B ?C))
X
END_OF_FILE
if test 1617 -ne `wc -c <'prolog1.2/ex.pro'`; then
    echo shar: \"'prolog1.2/ex.pro'\" unpacked with wrong size!
fi
# end of 'prolog1.2/ex.pro'
fi
if test -f 'prolog1.2/flounder.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/flounder.ss'\"
else
echo shar: Extracting \"'prolog1.2/flounder.ss'\" \(742 characters\)
sed "s/^X//" >'prolog1.2/flounder.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Flounder:  maintain dlist of delayed goals
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define (flounder! goal)
X	(if	debug?
X		(begin	(display "in flounder!() with goal:")
X			(display (term-instantiate (goal-term goal)))
X			(newline)))
X	(dlist-delete! goal FLOUNDERED-GOALS)
X	(dlist-insert-anywhere! goal FLOUNDERED-GOALS))
X
X(define (unflounder! goal)
X	(if	debug?
X		(begin	(display "in unflounder!() with goal:")
X			(display (term-instantiate (goal-term goal)))
X			(newline)))
X	(dlist-delete! goal FLOUNDERED-GOALS))
X
X(define (unflounder-all!)
X	(set! FLOUNDERED-GOALS (make-dlist)))
X
X(define FLOUNDERED-GOALS (make-dlist))
X
END_OF_FILE
if test 742 -ne `wc -c <'prolog1.2/flounder.ss'`; then
    echo shar: \"'prolog1.2/flounder.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/flounder.ss'
fi
if test -f 'prolog1.2/goals.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/goals.ss'\"
else
echo shar: Extracting \"'prolog1.2/goals.ss'\" \(3226 characters\)
sed "s/^X//" >'prolog1.2/goals.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Goals:  implemented as vectors of the form #(id term pred) where
X;;;         id is a retry count for the goal,
X;;;         term is the term (see terms.ss),
X;;;         pred is the predicate (see pred.ss) in the form #(when what how).
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define make-goal
X  (let ((n 0))
X    (lambda (term program)
X      (set! n (1+ n))
X      (vector   ; should check to see if table-lookup returns #f
X       n
X       term
X       (assoc-value (table-lookup (term->functor/arity term) program))))))
X
X(define (goal-id goal)
X  (vector-ref goal 0))
X
X(define (goal-term goal)
X  (vector-ref goal 1))
X
X(define (goal-pred goal)
X  (vector-ref goal 2))
X
X;;; Try to run goal for the first time.
X(define (goal-first-try! goal s-run s-delay f)
X	(if	debug?
X		(begin	(display "goal-first-try! ")
X			(display (term-instantiate (goal-term goal)))))
X	(if	((pred-when (goal-pred goal)) goal)
X		(begin	(if debug? (begin (display " ...running") (newline)))
X			(s-run f))
X		(let	((var-set (term-var-set (goal-term goal))))
X			(if debug?
X				(begin	(display " ...delaying")
X					(newline)))
X			(for-each
X						;;; delay on all variables
X				(lambda (var)
X					(var-add-constraint! goal var
X						'FRONT))
X				var-set)
X			(flounder! goal)
X			(s-delay
X				(lambda ()
X					(unflounder! goal)
X					(for-each
X						;;; undelay on all variables
X						(lambda (var)
X							(var-del-constraint!
X								goal var))
X						var-set)
X					(f))))))
X
X;;; Try to wake up goal given that ivar was just instantiated.
X(define (goal-wake-try! goal ivar s-run s-delay f)
X	(if	debug?
X		(begin	(display "goal-wake-try! ")
X			(display (term-instantiate (goal-term goal)))))
X	(if	((pred-when (goal-pred goal)) goal)
X		(let	((var-set (term-var-set (goal-term goal))))
X			(if debug? (begin (display " ...waking") (newline)))
X			(for-each
X						;;; undelay on all variables
X				(lambda (var)
X					(var-del-constraint! goal var))
X				var-set)
X			(unflounder! goal)
X			(s-run (lambda ()
X				(if debug?
X				    (begin
X					(display "failing out of awakened...")
X					(newline)))
X				(flounder! goal)
X				(for-each
X						;;; redelay on all variables
X					(lambda (var)
X						(var-add-constraint! goal var
X							'FRONT))
X					var-set)
X				(if debug?
X				    (begin
X					(display "failed out of awakened.")
X					(newline)))
X				(f))))
X		(let	((var-set (term-var-set ivar)))
X			(if debug? (begin (display " ...still delaying")
X				(newline)))
X						;;; but constraints are not
X						;;; erased from ivar!!??##@@$$
X			(for-each
X						;;; delay on all variables
X				(lambda (var)
X					(var-add-constraint! goal var 'FRONT))
X				var-set)
X			(s-delay
X				(lambda ()
X						;;; undelay on all variables
X					(for-each
X						(lambda (var)
X							(var-del-constraint!
X								goal var))
X						var-set)
X					(f))))))
X
X;;; Execute newly-woken goal immediately.
X(define (awaken-goal-immediately! goal program s f)
X	(and-branch goal program s f))
X
X;;; Prepare to execute newly-woken goal some time soon.
X(define (awaken-goal-soon! goal program s f)
X	(schedule! goal)
X	(s (lambda ()
X		(unschedule! goal)
X		(f))))
X
X(define awaken-goal! awaken-goal-soon!)
END_OF_FILE
if test 3226 -ne `wc -c <'prolog1.2/goals.ss'`; then
    echo shar: \"'prolog1.2/goals.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/goals.ss'
fi
if test -f 'prolog1.2/interval.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/interval.ss'\"
else
echo shar: Extracting \"'prolog1.2/interval.ss'\" \(785 characters\)
sed "s/^X//" >'prolog1.2/interval.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Interval:  interval arithmetic routines
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define arith-debug? #f)
X(define (arith-debug arg)
X	(if	arith-debug?
X		(begin	(display arg)
X			(newline))))
X
X(define (load-interval-arith filename)
X	(load (string-append interval-source-prefix filename)))
X
X(load-interval-arith "precision.ss")
X(load-interval-arith "prim.ss")
X(load-interval-arith "add.ss")
X(load-interval-arith "mult.ss")
X(load-interval-arith "int.ss")
X(load-interval-arith "geq.ss")
X(load-interval-arith "gt.ss")
X(load-interval-arith "neq.ss")
X(load-interval-arith "split.ss")
X(load-interval-arith "relax.ss")
X(load-interval-arith "unify.ss")
X
X(set! intervals? #t)
END_OF_FILE
if test 785 -ne `wc -c <'prolog1.2/interval.ss'`; then
    echo shar: \"'prolog1.2/interval.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/interval.ss'
fi
if test -f 'prolog1.2/polytest.pro' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/polytest.pro'\"
else
echo shar: Extracting \"'prolog1.2/polytest.pro'\" \(3208 characters\)
sed "s/^X//" >'prolog1.2/polytest.pro' <<'END_OF_FILE'
X;;This file will eventually contain procedures for solving general polynomials.
X;;It uses the idea that moving the origin of a polynomial is the same as
X;; applying the Krawchuk derivative.
X
X(when (eq ?X ?Y))
X(what (eq ?X ?X))
X
X(when (poly ?X ?L ?Y) (nonvar ?L))
X(what (poly ?X () 0.0))
X(what (poly ?X (?H . ?L) ?Y)
X;;    (monitor ?Y ("=Y" (?H . ?L) ?X))
X;;    (monitor ?T0 ("=T0" (?H . ?L) ?X))
X;;    (monitor ?T1 ("=T1" (?H . ?L) ?X))
X      (poly ?X ?L ?T0) (mult ?X ?T0 ?T1) (add ?T1 ?H ?Y))
X
X(when (test_poly ?Y))
X(what (test_poly ?Y) (poly 2 (1 1 1) ?Y))
X(what (test_poly ?Y) (poly 2 (0 0 1) ?Y))
X
X;;X^2=C also use Z=X-1 (X=Z+1) so Z^2 + 2Z + 1 - C = 0
X(when (sqrt2 ?C ?X))
X(what (sqrt2 ?C ?X)  ;; ?X = sqrt(?C)
X      (add ?Z 1 ?X)
X      (mult ?X ?X ?C)
X      (poly ?Z (1 2 1) ?C)
X)
X
X(when (test_sqrt2))
X(what (test_sqrt2) (monitor ?X "?X") (sqrt2 2 ?X))
X
X;;The old way of doing sqrt (just for comparison)
X(when (split_poly ?X))
X(what (split_poly ?X) (geq -1 ?X) (split ?X))
X(what (split_poly ?X) (gt ?X -1) (geq 0 ?X) (split ?X))
X(what (split_poly ?X) (gt ?X  0) (geq 1 ?X) (split ?X))
X(what (split_poly ?X) (gt ?X  1) (split ?X))
X
X(when (sqrt1 ?C ?X))
X(what (sqrt1 ?C ?X) (mult ?X ?X ?C) (split_poly ?X))
X
X(when (test_sqrt1))
X(what (test_sqrt1) (monitor ?X "?X") (sqrt1 2 ?X))
X
X;;Translate the origin of polynomial in ?X by ?A
X;;that is, reformulate as polynomial in ?Z where ?Z = ?X - ?A
X(when (poly_a ?A ?X ?L ?Y))
X(what (poly_a ?A ?X ?L ?Y)
X      (monitor ?Z ("=Z" ?A ?L ?M))
X      (add ?Z ?A ?X)
X      (pa ?A ?L ?M)
X      (poly ?Z ?M ?Y)
X)
X
X;;compute coefficients of polynomial in ?Z
X(when (pa ?A ?L ?M) (nonvar ?L))
X(when (pa ?A ?L ?M) (nonvar ?M))
X(what (pa ?A () ()))
X(what (pa ?A (?H . ?L) ?M)
X      (pa ?A ?L ?T0)
X      (pmult ?A ?T0 ?T1)
X      (padd (?H . ?T0) ?T1 ?M) ;;?M = ?A*?T0 + ?Z*?T0
X)
X
X;;multiply a list by a constant
X(when (pmult ?C ?L ?M) (nonvar ?L))
X(when (pmult ?C ?L ?M) (nonvar ?M))
X(what (pmult ?C () ()))
X(what (pmult ?C (?A . ?L) (?B . ?M))
X      (mult ?C ?A ?B)
X      (pmult ?C ?L ?M)
X)
X
X;;Add two lists (extend if necessary)
X(when (padd ?L ?M ?N) (nonvar ?L) (nonvar ?M))
X(when (padd ?L ?M ?N) (nonvar ?L) (nonvar ?N))
X(when (padd ?L ?M ?N) (nonvar ?M) (nonvar ?N))
X(what (padd ()  ?N  ?N)
X      (not (eq () ?N))
X)
X(what (padd ?N  ()  ?N)
X      (not (eq () ?N))
X)
X(what (padd ()  ()  ()))
X(what (padd (?A . ?L) (?B . ?M) (?C . ?N))
X      (add ?A ?B ?C)
X      (padd ?L ?M ?N)
X)
X
X(when (test_pa ?L))
X(what (test_pa ?L) (pa 0 (1 2 3) ?L)) ;;;?L = (1 2 3)
X(what (test_pa ?L) (pa  1 (1 2 3) ?L)) ;;;?L = (6 8 3)
X(what (test_pa ?L) (pa -1 (1 2 3) ?L)) ;;;?L = (2 -4 3)
X
X
X(when (cube_rt ?A ?K))
X(what (cube_rt ?A ?K)
X	(monitor ?X " = X")
X	(eq ?P  (0 0 0 1)) ;;X^3
X	(ka ?K ?X ?P ?Z)
X	(eq ?Z ?A) ;;don't fire constraints until all set up
X)
X
X;;;apply a list of Krawchuck constants against a polynomial
X(when (ka ?K ?X ?P ?A) (nonvar ?K))
X(what (ka () ?X ?P ?A))
X(what (ka (?Ka . ?K) ?X ?P ?A)
X	(poly_a ?Ka ?X ?P ?A)
X	(ka ?K ?X ?P ?A)
X)
X
X(when (test_ka ?K ?P))
X(what (test_ka ?K ?P)
X	(monitor ?X "X = ")
X	(monitor ?Y "Y = ")
X	(ka ?K ?X ?P ?Y)
X	(eq ?Y 0)
X)
X
X;;;experiments with cube root
X(when (crt1))
X(what (crt1)
X	(cube_rt 1 (0))
X)
X(when (crt2))
X(what (crt2)
X	(cube_rt 1 (0 1))
X)
END_OF_FILE
if test 3208 -ne `wc -c <'prolog1.2/polytest.pro'`; then
    echo shar: \"'prolog1.2/polytest.pro'\" unpacked with wrong size!
fi
# end of 'prolog1.2/polytest.pro'
fi
if test -f 'prolog1.2/predicates.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/predicates.ss'\"
else
echo shar: Extracting \"'prolog1.2/predicates.ss'\" \(745 characters\)
sed "s/^X//" >'prolog1.2/predicates.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Predicates:  implemented as vectors of the form #(when what how).
X;;;              See compile.ss for details of these components.
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define (make-pred)
X  (vector (make-dlist) (make-dlist) (make-dlist)))
X
X(define (pred-when pred)
X  (vector-ref pred 0))
X
X(define (pred-when! pred wh)
X  (vector-set! pred 0 wh))
X
X(define (pred-what pred)
X  (vector-ref pred 1))
X
X(define (pred-what! pred what)
X  (vector-set! pred 1 what))
X
X(define (pred-how pred)
X  (vector-ref pred 2))
X
X(define (pred-how! pred how)
X  (vector-set! pred 2 how))
X
X(define (pred-how? pred)
X	(not (null? (pred-how pred))))
END_OF_FILE
if test 745 -ne `wc -c <'prolog1.2/predicates.ss'`; then
    echo shar: \"'prolog1.2/predicates.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/predicates.ss'
fi
if test -f 'prolog1.2/programs.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/programs.ss'\"
else
echo shar: Extracting \"'prolog1.2/programs.ss'\" \(4295 characters\)
sed "s/^X//" >'prolog1.2/programs.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Clause declarations: implemented as lists of the form (type . clause)
X;;;                      where type is one of 'when, 'what or 'how, and
X;;;                      clause is an appropriate structure.
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X;;; returns type - one of what, when
X(define clause-dec-type car)
X
X(define clause-dec-clause cdr)
X
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Programs: tables of predicates 
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X
X(define (make-program) (make-table (make-assoc '!@$%^&* (make-pred))))
X
X(define (clause-insert! clause-dec program)
X  (let* ((type (clause-dec-type clause-dec))
X         (clause (clause-dec-clause clause-dec))
X         (functor/arity
X          (term->functor/arity (clause-head clause)))
X         (assoc (table-lookup functor/arity program))
X         (pred (if assoc 
X                   (assoc-value assoc)
X                   (begin
X                    (table-insert!
X                     (make-assoc functor/arity (make-pred)) program)
X                    (assoc-value (table-lookup functor/arity program))))))
X    (case type
X      ((when) (dlist-insert-back! clause (pred-when pred)))
X      ((what) (dlist-insert-back! clause (pred-what pred)))
X      ((how)  (dlist-insert-back! clause (pred-how pred)))
X      (else (error 'clause "file ~s: clause ~s" file clause)))))
X  
X
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Program-load: loads a prolog file
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define (program-load file-name-list)
X	(let	((program (make-program)))
X		(for-each (lambda (file-name)
X			(let	((file (open-input-file file-name)))
X				(define (load-program!)
X					(let	((clause-dec (read file)))
X						(if	(eof-object? clause-dec)
X							#t
X							(begin
X								(clause-insert!
X								     clause-dec
X									program)
X							(load-program!)))))
X				(load-program!)))
X			file-name-list)
X		program))
X
X
X;;; load a program from files named in file-name-list and solve queries about it
X(define (prolog . file-name-list)
X	(let	((program (program-load file-name-list)))
X		(compile-program! program)
X		(newline)
X		(display "Prolog 1.2 with ")
X		(if intervals? (display "Logical Arithmetic and "))
X		(display "Delays")
X		(newline)
X		(solve-queries program)))
X
X(define (prompt) (display "?- ") (read))
X
X
X(define (read-non-newline-char)
X  (let ((ch (read-char)))
X    (if (eq? ch #\newline)
X	(read-non-newline-char)
X	ch))
X)
X
X(define want-all-solutions? #f)
X
X(define (want-more-solutions?)
X  (if want-all-solutions?
X      #t
X      (begin
X	(display "More? ") (flush-output-port)
X	(let ((ch (read-non-newline-char)))
X	  (cond ((eof-object? ch) #f)
X		((eq? ch #\;) #t)
X		((eq? ch #\.) #f)
X		((eq? ch #\,) (set! want-all-solutions? #t) #t)
X		(else
X		 (display "Type one of the following:") (newline)
X		 (display "  ;   display next solution") (newline)
X		 (display "  ,   display all remaining solutions") (newline)
X		 (display "  .   skip remaining solutions") (newline)
X		 (want-more-solutions?))))
X      )
X  )
X)
X
X(define (solve-queries program)
X	(let*	((in (prompt))
X		 (query (if (or (eof-object? in) (eq? in 'q))
X			    'q
X			    ((compile-what-clause in)))))
X		(if	(eq? query 'q)
X			'bye
X			(let	((t (cpu-time)))
X				(set! want-all-solutions? #f)
X				(unschedule-all!)
X				(unflounder-all!)
X				(if intervals? (init-arith-goal-lists!))
X				(and-node query program
X					(lambda (f)
X						(display "Solution: ")
X						(display
X							(term-instantiate query))
X						(newline)
X						(display "Floundered goals:")
X						(newline)
X						(for-each (lambda (g)
X							(display "  ")
X							(display
X							 (term-instantiate
X							  (goal-term g)))
X							(newline))
X						     (dlist->list
X							FLOUNDERED-GOALS))
X						(if intervals?
X							(display-goal-lists))
X						(if (want-more-solutions?)
X						    (f)))
X					(lambda ()
X						(display "no more solutions")
X						(newline)))
X				(let ((t2 (cpu-time)))
X				  (if (< t t2)
X				      (display (list "time in seconds: "
X						     (/ (- t2 t) 1000.0)))))
X				(newline)
X				(solve-queries program)))))
X
END_OF_FILE
if test 4295 -ne `wc -c <'prolog1.2/programs.ss'`; then
    echo shar: \"'prolog1.2/programs.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/programs.ss'
fi
if test -f 'prolog1.2/prolog.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/prolog.ss'\"
else
echo shar: Extracting \"'prolog1.2/prolog.ss'\" \(2194 characters\)
sed "s/^X//" >'prolog1.2/prolog.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Prolog:  top-level file, which loads the rest of the system.
X;;;          Interval arithmetic can be disabled.
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X;; The following three definitions specify the locations of the various
X;; parts of the Prolog interpreter, and are prepended to the names of
X;; system files loaded:
X;;	prolog-source-prefix	the Prolog interpreter (*.ss)
X;;	interval-source-prefix	interval arithmetic (*.ss)
X;;	builtin-pred-prefix	built-in predicates (*.pro)
X
X(define prolog-source-prefix "/home/srdg/dewar/prolog/scheme/R1.2/")
X
X(define interval-source-prefix
X	(string-append prolog-source-prefix "Interval/"))
X
X(define builtin-pred-prefix prolog-source-prefix)
X
X(define debug? #f)
X(define user-debug? #f)
X(define (user-debug arg)
X	(if	user-debug?
X		(begin	(display arg)
X			(newline))))
X
X(define (load-prolog filename)
X	(load (string-append prolog-source-prefix filename)))
X
X(load-prolog "compatibility.ss")
X(load-prolog "tables.ss")
X(load-prolog "clauses.ss")
X(load-prolog "predicates.ss")
X(load-prolog "goals.ss")
X(load-prolog "dlists.ss")
X(load-prolog "programs.ss")
X(load-prolog "compile.ss")
X(load-prolog "terms.ss")
X(load-prolog "search.ss")
X(load-prolog "schedule.ss")
X(load-prolog "flounder.ss")
X
X;; To disable interval arithmetic, set intervals? to #f and comment out
X;; the load line for interval.ss.
X(define intervals? #t)
X(load-prolog "interval.ss")
X
X(define (pro . file-name-list)
X    (begin
X      (newline)
X      (display "A Prolog goal is an unquoted LIST of predicate calls.")
X      (newline)
X      (display "To toggle predicate tracing, type as a Prolog goal: ((debug))")
X      (newline)
X      (if intervals?
X	  (eval (append
X		    (list 'prolog
X			  (string-append builtin-pred-prefix "builtin.pro")
X			  (string-append builtin-pred-prefix "interval.pro"))
X		    file-name-list))
X	  (eval (append
X		    (list 'prolog
X			  (string-append builtin-pred-prefix "builtin.pro"))
X		    file-name-list))
X      )
X    )
X)
X
X(define (greetings)
X  (display "To start the Prolog interpreter, type:  (pro <file-names>...)")
X  (newline)
X)
X
X(greetings)
END_OF_FILE
if test 2194 -ne `wc -c <'prolog1.2/prolog.ss'`; then
    echo shar: \"'prolog1.2/prolog.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/prolog.ss'
fi
if test -f 'prolog1.2/schedule.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/schedule.ss'\"
else
echo shar: Extracting \"'prolog1.2/schedule.ss'\" \(1968 characters\)
sed "s/^X//" >'prolog1.2/schedule.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Schedule:  maintain dlist of scheduled (woken) goals
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define (schedule! goal)
X	(if	debug?
X		(begin	(display "in schedule!() with goal")
X			(display (goal-id goal))
X			(display ":")
X			(display (term-instantiate (goal-term goal)))
X			(display "queue:")
X			(display (map (lambda (g) (goal-id g))
X					(dlist->list SCHEDULED-GOALS)))
X			(newline)))
X	(if (memq goal (dlist->list SCHEDULED-GOALS))
X		(if	debug?
X			(begin
X				(display "WARNING:  duplicate goal in schedule!()")
X				(newline)))
X		(dlist-insert-back! goal SCHEDULED-GOALS))
X)
X
X(define (reschedule! goal)
X	(if	debug?
X		(begin	(display "in reschedule!() with goal")
X			(display (goal-id goal))
X			(display ":")
X			(display (term-instantiate (goal-term goal)))
X			(display "queue:")
X			(display (map (lambda (g) (goal-id g))
X					(dlist->list SCHEDULED-GOALS)))
X			(newline)))
X	(dlist-insert-front! goal SCHEDULED-GOALS)
X)
X
X(define (unschedule! goal)
X	(if	debug?
X		(begin	(display "in unschedule!() with goal")
X			(display (goal-id goal))
X			(display ":")
X			(display (term-instantiate (goal-term goal)))
X			(display "queue:")
X			(display (map (lambda (g) (goal-id g))
X					(dlist->list SCHEDULED-GOALS)))
X			(newline)))
X	(dlist-delete! goal SCHEDULED-GOALS)
X)
X
X(define (unschedule-all!)
X	(if	debug?
X		(begin	(display "in unschedule-all!()")
X			(newline)))
X	(set! SCHEDULED-GOALS (make-dlist)))
X
X(define SCHEDULED-GOALS (make-dlist))
X
X(define (scheduler program s f)
X	(if	debug?
X		(begin	(display "in scheduler() with queue ")
X			(display (map (lambda (g) (goal-id g))
X					(dlist->list SCHEDULED-GOALS)))
X			(newline)))
X	(if (dlist-empty? SCHEDULED-GOALS)
X		(s f)
X		(let	((goal (dlist-delete-front! SCHEDULED-GOALS)))
X			(and-branch goal program 
X				(lambda (fail) (scheduler program s fail))
X				(lambda ()
X					(reschedule! goal)
X					(f)))))
X)
END_OF_FILE
if test 1968 -ne `wc -c <'prolog1.2/schedule.ss'`; then
    echo shar: \"'prolog1.2/schedule.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/schedule.ss'
fi
if test -f 'prolog1.2/tables.ss' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'prolog1.2/tables.ss'\"
else
echo shar: Extracting \"'prolog1.2/tables.ss'\" \(661 characters\)
sed "s/^X//" >'prolog1.2/tables.ss' <<'END_OF_FILE'
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X;;;
X;;; Tables:  implemented with association lists and dlists.
X;;;          They associate predicate names with lists of clauses.
X;;;
X;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
X
X(define make-assoc cons)
X(define assoc-key car)
X(define assoc-key! set-car!)
X(define assoc-value cdr)
X(define assoc-value! set-cdr!)
X
X;;; let user set up intial assoc
X(define (make-table assoc) (cons assoc '()))
X
X;;; push another association on
X(define (table-insert! assoc tab)
X  (set-cdr! tab (cons (car tab) (cdr tab)))
X  (set-car! tab assoc))
X
X(define table-lookup assq)
END_OF_FILE
if test 661 -ne `wc -c <'prolog1.2/tables.ss'`; then
    echo shar: \"'prolog1.2/tables.ss'\" unpacked with wrong size!
fi
# end of 'prolog1.2/tables.ss'
fi
echo shar: End of archive 1 \(of 3\).
cp /dev/null ark1isdone
MISSING=""
for I in 1 2 3 ; do
    if test ! -f ark${I}isdone ; then
	MISSING="${MISSING} ${I}"
    fi
done
if test "${MISSING}" = "" ; then
    echo You have unpacked all 3 archives.
    rm -f ark[1-9]isdone
else
    echo You still need to unpack the following archives:
    echo "        " ${MISSING}
fi
##  End of shell archive.
exit 0
